---
stages:
  - clean
  - prepare
  - configure
  - deploy
  - wait
  - postinstall
  - postconfigure

variables:
  CI_FILE: gitlab-ci.template.yml
  WORKDIR: /opt/oom-collection/
  OOM_COLLECTION_DOCKER_IMAGE:
    registry.gitlab.com/orange-opensource/lfn/onap/oom-collection
  OOM_COLLECTION_DOCKER_TAG: latest
  CHAINED_CI_INIT: scripts/chained-ci-init.sh
  GIT_SUBMODULE_STRATEGY: recursive

.deployment_and_test: &deployment_and_test
  tags:
    - kubernetes
  image: ${OOM_COLLECTION_DOCKER_IMAGE}:${OOM_COLLECTION_DOCKER_TAG}
  artifacts:
    paths:
      - vars/openstack_infos.yml
      - vars/cluster.yml
    when: always
  before_script:
    # Copy project file and artifacts into WORKDIR
    - curl -s ifconfig.me || true
    - cd ${WORKDIR}
    - . ./${CHAINED_CI_INIT} -a -i inventory/infra
    - if $(ls ${CI_PROJECT_DIR}/*&>/dev/null);
      then cp -rf ${CI_PROJECT_DIR}/* ${WORKDIR}; fi
  after_script:
    - cd ${WORKDIR}
    - ./scripts/clean.sh
    # Go back to CI_PROJECT_DIR to save artifacts
    - if $(ls vars>&/dev/null); then cp -rf vars ${CI_PROJECT_DIR}; fi
    - cd ${CI_PROJECT_DIR}
  retry: 1

.only: &only
  only:
    refs:
      - schedules
      - triggers
      - web
      - external
      - pipelines

# Clean
clean:
  stage: clean
  script:
    - ./run.sh clean
  <<: *deployment_and_test
  only:
    variables:
      - $CLEAN == 'True'
      - $CLEAN == 'true'
      - $CLEAN == 'Yes'
      - $CLEAN == 'yes'
    refs:
      - schedules
      - triggers
      - web
  retry: 2

prepare:
  stage: prepare
  script:
    - ./run.sh prepare
  <<: *deployment_and_test
  <<: *only

configure:
  stage: configure
  variables:
    DEPLOYMENT_TYPE: full
  script:
    - ./run.sh configure
  <<: *deployment_and_test
  <<: *only

deploy:
  stage: deploy
  script:
    - ./run.sh deploy
  <<: *deployment_and_test
  <<: *only

wait_for_end_of_install:
  stage: wait
  allow_failure: true
  timeout: 1h
  script:
    - ./run.sh wait
  <<: *deployment_and_test
  <<: *only

# Postconfiguration
postconfiguration:
  stage: postconfigure
  allow_failure: true
  script:
    - ./run.sh postconfiguration
  <<: *deployment_and_test
  <<: *only

  # Postconfiguration
postinstallation:
  stage: postinstall
  script:
    - ./run.sh postinstallation
  <<: *deployment_and_test
  <<: *only
